#!/usr/bin/env python

from scapy.all import *
import sys, signal, threading, string

if len(sys.argv) != 3:
	print "Usage: %s <destination> <port>"
	sys.exit(1)

destination = sys.argv[1]
port = sys.argv[2]

C2S = []
S2C = []

def dump( data, filename, header ):

	print "[+] Writing packet lengths to \"%s\"." % filename
	fd = open(filename, "w")
	fd.write(header + "\n" + data + "\n")
	fd.close()

def process( pkt ):

	if not Raw in pkt:
		return

	length = len(pkt["Raw"])
	# Ignore packets without payload (e.g. TCP ACKs).
	if length == 0:
		return

	if pkt["IP"].dst == destination:
		print "C -> S: %d" % length
		C2S.append(length)
	else:
		print "C <- S: %d" % length
		S2C.append(length)


if __name__ == '__main__':

	try:
		sniff(filter="host %s and port %s" % (destination, port), \
			prn=lambda pkt: process(pkt))
	except KeyboardInterrupt:
		print "\n[+] Stopping sniffing."

	dump(string.join([str(x) for x in C2S], "\n"), "C2S.txt", "C2S")
	dump(string.join([str(x) for x in S2C], "\n"), "S2C.txt", "S2C")
